문제 난이도 | 유형 |
🥇골드 5티어 | 데이크스트라, 최단 경로, 우선 순위 큐 |
문제
시간 제한 | 메모리 제한 | 제출 | 정답 | 맞힌 사람 | 정답 비율 |
0.5 초 | 128 MB | 59634 | 18383 | 12030 | 32.072% |
N개의 도시가 있다. 그리고 한 도시에서 출발하여 다른 도시에 도착하는 M개의 버스가 있다. 우리는 A번째 도시에서 B번째 도시까지 가는데 드는 버스 비용을 최소화 시키려고 한다. A번째 도시에서 B번째 도시까지 가는데 드는 최소비용을 출력하여라. 도시의 번호는 1부터 N까지이다.
입력
첫째 줄에 도시의 개수 N(1 ≤ N ≤ 1,000)이 주어지고 둘째 줄에는 버스의 개수 M(1 ≤ M ≤ 100,000)이 주어진다. 그리고 셋째 줄부터 M+2줄까지 다음과 같은 버스의 정보가 주어진다. 먼저 처음에는 그 버스의 출발 도시의 번호가 주어진다. 그리고 그 다음에는 도착지의 도시 번호가 주어지고 또 그 버스 비용이 주어진다. 버스 비용은 0보다 크거나 같고, 100,000보다 작은 정수이다.
그리고 M+3째 줄에는 우리가 구하고자 하는 구간 출발점의 도시번호와 도착점의 도시번호가 주어진다. 출발점에서 도착점을 갈 수 있는 경우만 입력으로 주어진다.
출력
첫째 줄에 출발 도시에서 도착 도시까지 가는데 드는 최소 비용을 출력한다.
예제 입력
5
8
1 2 2
1 3 3
1 4 1
1 5 10
2 4 2
3 4 1
3 5 1
4 5 3
1 5
예제 출력
4
풀이
데이크스트라 알고리즘과 우선순위 큐로 풀 수 있다. 시간초과 때문에 고생을 많이 한 문제이다. 나의 정신 상태는 아래 사진과 같았다.. 내가 계속 시간 초과로 고생했던 이유는 A 노드에서 B노드로 가는 길이 여러개일 수 있다는 것을 간과했기 때문이다. 그 부분만 해결되면 기본 데이크스트라 알고리즘과 우선순위 큐를 만들어 문제를 해결할 수 있다.
데이크스트라 알고리즘의 흐름은 아래와 같다.
- 시작점을 제외한 모든 정점의 거리를 무한으로 설정하고, 시작점은 0으로 설정
- 시작점 선택
- 선택한 정점에서 갈 수 있는 정점의 거리를 정점(해당 정점까지의 최단 거리) 값 + 간선(거리) 값으로 갱신
- 선택한 정점을 방문 처리
- 이미 방문한 정점과 무한인 정점을 제외하고 가장 최단 거리인 정점을 선택
- 더 이상 방문할 수 있는 정점이 없을 때 까지 3번, 4번, 5번을 반복
- 도착점의 값을 확인
코드
const readline = require("readline");
const rl = readline.createInterface({
input: process.stdin,
output: process.stdout,
});
const input = [];
rl.on("line", function (line) {
input.push(line);
}).on("close", function () {
const N = Number(input[0]);
dijkstra(input, N);
process.exit();
});
class MinHeap {
constructor() {
this.heap = [null];
}
push(value) {
this.heap.push(value);
let currentIndex = this.heap.length - 1;
let parentIndex = Math.floor(currentIndex / 2);
while (parentIndex !== 0 && this.heap[parentIndex].cost > value.cost) {
this._swap(parentIndex, currentIndex);
currentIndex = parentIndex;
parentIndex = Math.floor(currentIndex / 2);
}
}
pop() {
if (this.isEmpty()) return;
if (this.heap.length === 2) return this.heap.pop();
const returnValue = this.heap[1];
this.heap[1] = this.heap.pop();
let currentIndex = 1;
let leftIndex = 2;
let rightIndex = 3;
while (
(this.heap[leftIndex] &&
this.heap[currentIndex].cost > this.heap[leftIndex].cost) ||
(this.heap[rightIndex] &&
this.heap[currentIndex].cost > this.heap[rightIndex].cost)
) {
if (this.heap[leftIndex] === undefined) {
this._swap(rightIndex, currentIndex);
} else if (this.heap[rightIndex] === undefined) {
this._swap(leftIndex, currentIndex);
} else if (this.heap[leftIndex].cost > this.heap[rightIndex].cost) {
this._swap(rightIndex, currentIndex);
} else if (this.heap[leftIndex].cost <= this.heap[rightIndex].cost) {
this._swap(leftIndex, currentIndex);
}
leftIndex = currentIndex * 2;
rightIndex = currentIndex * 2 + 1;
}
return returnValue;
}
isEmpty() {
return this.heap.length === 1;
}
_swap(a, b) {
[this.heap[a], this.heap[b]] = [this.heap[b], this.heap[a]];
}
}
function dijkstra(input, N) {
const [start, end] = input[input.length - 1].split(" ").map(Number);
const heap = new MinHeap();
const dist = Array(N + 1).fill(Infinity);
const graph = Array.from(Array(N + 1), () => new Object());
heap.push({ node: start, cost: 0 });
dist[start] = 0;
//그래프 생성
for (let i = 2; i < input.length - 1; i++) {
const [src, dest, cost] = input[i].split(" ").map(Number);
if (graph[src][dest] === undefined) {
graph[src][dest] = cost;
} else {
if (graph[src][dest] > cost) {
graph[src][dest] = cost;
}
}
}
while (!heap.isEmpty()) {
const { node: current, cost: currentCost } = heap.pop();
if (currentCost > dist[current]) continue;
for (const dest in graph[current]) {
if (currentCost > dist[dest]) continue;
const cost = graph[current][dest];
const nextCost = cost + currentCost;
if (nextCost < dist[dest]) {
dist[dest] = nextCost;
heap.push({ node: dest, cost: nextCost });
}
}
}
console.log(dist[end]);
}
'CS > 알고리즘' 카테고리의 다른 글
[백준 #1644] 소수의 연속합, 자바스크립트 풀이 (0) | 2022.10.11 |
---|---|
[백준 #1806] 부분합, 자바스크립트 풀이 (0) | 2022.10.11 |
[백준 #7576] 토마토, 자바스크립트 풀이 (1) | 2022.10.08 |
[백준 #17144] 미세먼지 안녕!, 자바스크립트 풀이 (0) | 2022.10.07 |
[백준 #3197] 백조의 호수, 자바스크립트 풀이 (0) | 2022.10.04 |